function [U,R,ep] = OPAST(x,obsInd,lambda,U,R)
% x: center subtracted observation
% lambda: forgetting factor
% U: recursively updated subspace basis
% R: matrix used in OPAST, recursively updated
if ~isequal(obsInd,true(length(x),1))
    U_omega = U(obsInd,:);
    y = U_omega\x(obsInd);
else
    y = U'*x;
end
q = 1/lambda*R*y;
gamma = 1/(1+y'*q);
p = gamma*(x-U*y);
p(~obsInd) = 0;
R = 1/lambda*R-gamma*(q*q');
norm_q = norm(q)^2;
norm_p = norm(p)^2;
tau = 1/norm_q*(1/sqrt(1+norm_p*norm_q)-1);
p_prime = tau*U*q+(1+tau*norm_q)*p;
U = U+p_prime*q';
ep = norm(U'*U-eye(size(U,2)),'fro');