function [node,res] = batchIni(X,d,method)
% initialize a node from batch data X: each column is a data point
% assume no missing entry
% method: "grouse","petrels_gs","petrels_fo"
[D,N] = size(X);
c = mean(X,2);
centerSub = X-repmat(c,[1,N]);

[u,s,~] = svd(centerSub,0);
node.basis = u(:,1:d);
node.center = c;
s = diag(s).^2/N;
node.spread = s(1:d);
node.error = sum(s(d+1:end));
node.deviate = node.error/(D-d);
node.father = 0;
node.left = -inf;
node.right = -inf;

if strcmp(method,'petrels_gs')
    node.R = repmat(eye(d),[1,1,D]);
elseif strcmp(method,'petrels_fo')
    node.R = eye(d); 
end

% if you need more information about the approximation using this node

%res = sum((centerSub-node.basis*node.basis'*centerSub).^2,1);
res = sum(centerSub.^2,1)-sum((node.basis'*centerSub).^2,1);