function U = grouse(v,idx,eta,U)
% Form some sparse matrices for easier matlab indexing


% solve LSE problem
v_omega = v(idx);
U_omega = U(idx,:);
w = U_omega\v_omega;% the left matrix should be full column rank

% predict full vector
p = U*w;

% compute residual
r = diag(idx)*(v-p);

%update subspace
sigma = norm(r)*norm(p);
U = U+((cos(sigma*eta)-1)*p/norm(p)+sin(sigma*eta)*r/norm(r))*w'/norm(w);