function [T,leafInd,iniRes] = iniTree(X,d,ep0,method,iniMethod)
D = size(X,1);
res = cell(1,1);
[T,res{1}] = batchIni(X,d,method);
leafInd = 1;
inspected = 1;
dataThisNode = {1:size(X,2)};
while ~isempty(inspected)
   ep = (D-d)*T(inspected(1)).deviate;
   if ep>ep0
       if strcmp(iniMethod,'kmeans')
           [dataInd,~] = kmeans(X(:,dataThisNode{inspected(1)})',2);
       elseif strcmp(iniMethod,'fuzzyc')
           [~,dataInd,~] = fcm(X(:,dataThisNode{inspected(1)})',2);
           dataInd = (dataInd(1,:)>0.5)+1;
       end
       
       leftInd = dataThisNode{inspected(1)}(dataInd==1);
       rightInd = dataThisNode{inspected(1)}(dataInd==2);
       [T(end+1),res{end+1}] = batchIni(X(:,leftInd),d,method);
       [T(end+1),res{end+1}] = batchIni(X(:,rightInd),d,method);
       
       T(inspected(1)).left = length(T)-1;
       T(inspected(1)).right = length(T);
       T(end-1).father = inspected(1);
       T(end).father = inspected(1);
       inspected = [inspected,length(T)-1,length(T)];
       dataThisNode = [dataThisNode,leftInd,rightInd];
       leafInd(leafInd==inspected(1)) = [];
       leafInd = [leafInd,length(T)-1,length(T)];
   end
   inspected(1) = [];
end

% append virtuals and get the mean and variance of training samples for
% sequential detection
iniRes = [res{leafInd}];
% mu0 = mean(iniRes);
% sigma0 = var(iniRes);
for i=leafInd
    leafData = X(:,dataThisNode{i});
    if strcmp(iniMethod,'kmeans')
        [dataInd,~] = kmeans(leafData',2);
    elseif strcmp(iniMethod,'fuzzyc')
        [~,dataInd,~] = fcm(leafData',2);
        dataInd = (dataInd(1,:)>0.5)+1;
    end
    
    %%%%%%
    if sum(dataInd==1)<d
        v2 = leafData(:,dataInd==2);
        borrowPt = knnsearch(leafData(:,dataInd==2)',...
            (mean(leafData(:,dataInd==1),2))','K',d+1-sum(dataInd==1));
        v1 = [leafData(:,dataInd==1),v2(:,borrowPt)];
    elseif sum(dataInd==2)<d
        v1 = leafData(:,dataInd==1);
        borrowPt = knnsearch(leafData(:,dataInd==1)',...
            (mean(leafData(:,dataInd==2),2))','K',d+1-sum(dataInd==2));
        v2 = [leafData(:,dataInd==2),v1(:,borrowPt)];
    else
        v1 = leafData(:,dataInd==1);
        v2 = leafData(:,dataInd==2);
    end
    %%%%%%
    
    %T(end+1) = batchIni(leafData(:,dataInd==1),d,method);
    T(end+1) = batchIni(v1,d,method);
    T(end).father = i;
    %T(end+1) = batchIni(leafData(:,dataInd==2),d,method);
    T(end+1) = batchIni(v2,d,method);
    T(end).father = i;
    T(i).left = length(T)-1;
    T(i).right = length(T);
end


