function [U,R] = petrels(x,obsInd,lambda,U,R)
% input---
% x is observation vector 
% obsInd is observation pattern, a boolean vector
% lambda is the forgetting factor
% U is recursive updated basis
% R is the inverse matrix used in the iteration

DIM = length(x);
a = U(obsInd,:)\x(obsInd,:);
for m=1:DIM
    beta = 1+1/lambda*a'*R(:,:,m)*a;
    v = 1/lambda*R(:,:,m)*a;
    if obsInd(m)
        R(:,:,m) = 1/lambda*R(:,:,m)-1/beta*(v*v');
    else
        R(:,:,m) = 1/lambda*R(:,:,m);
    end
%     if ~isempty(find(isnan(R(:,:,m))==1))
%         disp('!');
%     end
    U(m,:) = U(m,:)+obsInd(m)*(x(m)-a'*U(m,:)')*(R(:,:,m)*a)';
end