function [T,closestLeaf,closestV,currentErr] = updateNodes(T,leafInd,vt,obsInd,method,alpha,eta)
% input:
% method: 'grouse','petrels_gs','petrels_fo'
% eta: only for grouse

% output:
% T: updated tree structure
% closestLeaf: the closest leaf's index
% closestV: the closest leaf's closer virtual node's index
% currentErr: same as e_t


minDist = inf;
% in practice, since the virtual is the finest approximation, we calculate the
% distance between every virtual node and the newcomer


for thisLeaf = leafInd
    
    leftVir = T(thisLeaf).left;
    rightVir = T(thisLeaf).right;
    distL = dist2Node(T(leftVir),vt,obsInd);
    distR = dist2Node(T(rightVir),vt,obsInd);
    if distL<minDist
        closestV = leftVir;
        minDist = distL;
    end
    if distR<minDist
        closestV = rightVir;
        minDist = distR;
    end
    
end

updateThis = closestV;

while updateThis~=0
    [T(updateThis),errThisNode] = tiltShiftSubspace(T(updateThis),vt,obsInd,method,alpha,eta);
    updateThis = T(updateThis).father;
    
    if ismember(updateThis,leafInd) % the closest leaf's fitting error
        currentErr = errThisNode;
    end
    
end

closestLeaf = T(closestV).father;
